<?php
// $Id: heartbeat.admin.inc,v 1.1.2.3 2008/11/15 18:00:53 stalski Exp $ 
// by Jochen Stals - ONE-agency - www.one-agency.be


/**
 * Function to maintain and administer heartbeat settings
 *
 * @return settingsform
 */
function heartbeat_admin_settings() {
  $form['heartbeat_enabled'] = array(
    '#title' => t('Do you want to enable the heatbeat?'),
    '#type' => 'checkbox',
    '#size' => 5,
    '#default_value' => variable_get('heartbeat_enabled',1)
  );
  return system_settings_form($form);
}

/**
 * Function to maintain and administer heartbeat messages
 *
 * @return settingsform
 */
function heartbeat_messages(&$form_state, $edit = array()) {
  
  $form = array();
  $form['heartbeat_messages'] = array(
    '#type' => 'markup',
    '#value' => '<h2>'.t('Modules that describe heartbeat messages.').'</h2><p>These messages are passed to the translation function when parsed to view. This means that once theire are viewed, they are available for you to translate.</p>',
    '#tree' => TRUE,
  );
  $result = db_query("SELECT * FROM heartbeat_messages");
  $messages = array();
  while($row = db_fetch_object($result)) {
    $messages[] = $row;
  }
  if(count($messages) <= 0) {
    return t('Sorry, no heartbeat messages yet');
  }
  foreach($messages as $message) {
    $event = $message->event;
    if(!isset($form['heartbeat_messages'][$message->module])){
      $form['heartbeat_messages'][$message->module] = array(
		    '#type' => 'fieldset',
        '#title' => t($message->module. ' messages'),
        '#collapsible' => true,
        '#collapsed' => true,
      );
    }
    $form['heartbeat_messages'][$message->module][$message->event] = array(
      '#type' => 'textarea',
      '#title' => t($message->description),
      '#cols' => 10,
      '#rows' => 1,
      '#default_value' => empty($edit['message']) ? $message->message : $edit['message'],
    );    
  }

  $form['submit'] = array('#type' => 'submit', '#value' => t('Save'));
  if (isset($edit['event'])) {
    $form['delete'] = array('#type' => 'submit', '#value' => t('Delete'));
    $form['event'] = array('#type' => 'value', '#value' => $edit['event']);
  }
	  
  return $form;
}

/**
 * Accept the form submission heartbeat messages.
 */
function heartbeat_messages_submit($form, &$form_state) {
  if($form_state['clicked_button']['#value'] == t('Save')) {    
    $messages = $form_state['values']['heartbeat_messages'];
    foreach($messages as $module => $records) {
      foreach($records as $event => $message) {
        db_query("UPDATE {heartbeat_messages} SET message ='%s' 
          WHERE event = '%s' AND module = '%s'",
          $message, $event, $module);
      }
    }
  }
  //$form_state['redirect'] = 'admin/settings/heartbeat/messages';
  return;
}