<?php
// $Id: friendlist_activity.rules.inc,v 1.1.2.4 2008/11/16 17:01:26 stalski Exp $ 
// by Jochen Stals - ONE-agency - www.one-agency.be


# ACTIONS

/**
 * Implementation of hook_rules_action_info().
 * @ingroup rules
 */
function friendlist_activity_rules_action_info() {
  $info = array(
    'friendlist_activity_rules_action' => array(
      'label' => t('Logs relational friendlist activity'),
      'eval input' => array(
        'event_param',
        'uid_param',
        'uid_target_param',
        'message_param',
        'variables_param'
      ),
      'help' => 'Create a relation between users by logging their activities',
      'module' => 'User activity',
    ),
  );
  return $info;
}

/**
 * Action drupal message configuration form.
 */
function friendlist_activity_rules_action_form($settings, &$form) {
  user_activity_rules_default_action_form($settings, $form);
}

/**
 * Action Implementation: Log an activity
 *
 * @param array $settings
 * @param array form
 * @param array with two arrays (set_info and variables)
 * @ToDo  figure out what params mean / can do
 */
function friendlist_activity_rules_action($settings, $form=array(), $event_info=array()){
  //dsm(func_get_args()); 
  
  /**
   * @TODO: extra problem with translations. 
   * @example: This message "@username1 is now @relation_type with @username2."
   *    is fully translatable which is good. The problem is, that @relation_type 
   *    from friendlist has to be parsed through the t function as well.
   *  Attempt to fix it by calling relation_type here separatly 
   */ 

  
  // Requester 
  $data_requester = array();
  $data_requester['uid'] = $settings['uid_param'];
  $data_requester['uid_target'] = $settings['uid_target_param'];
  $data_requester['message'] = t($settings['message_param']);
  $data_requester['variables'] = $settings['variables_param'];
  $data_requester['event'] = $settings['event_param']; 
  $data_requester['hid'] = heartbeat_event_id($data_requester['event']);
  
  // decode variables here to preset the arguments
  $variables = heartbeat_decode_message_variables($data_requester['variables']);
  $args = array(
    '@username1' => $variables['username1'],
    '@username2' => $variables['username2'],
    '#relation_type' => t($variables['relation_type'])
  );
  user_activity_log($data_requester, $args); 
  
  
  // Requestee, override requester
  $data_requestee = $data_requester;
  $data_requestee['uid'] = $data_requester['uid_target'];
  $data_requestee['uid_target'] = $data_requester['uid'];
  
  $args = array(
    '@username1' => $variables['username2'],
    '@username2' => $variables['username1'],
    '#relation_type' => t($variables['relation_type'])
  );
  //dsm($data_requestee);
  user_activity_log($data_requestee, $args); 
}